package io.annaclemens.xivchat.model

enum class ServerOperation(val code: Byte) {
    Pong(1),
    Message(2),
    Shutdown(3),
    PlayerData(4),
    Availability(5),
    Channel(6),
    Backlog(7),
    PlayerList(8),
    LinkshellList(9);

    companion object {
        private val map = values().associateBy(ServerOperation::code)
        fun fromCode(code: Byte) = this.map[code]
    }
}

enum class ClientOperation(val code: Byte) {
    Ping(1),
    Message(2),
    Shutdown(3),
    Backlog(4),
    CatchUp(5),
    PlayerList(6),
    LinkshellList(7),
    Preferences(8),
    Channel(9);

    companion object {
        private val map = values().associateBy(ClientOperation::code)
        fun fromCode(code: Byte) = this.map[code]
    }
}
