package io.annaclemens.xivchat.ui.servers.scan

import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel

class ScannedServersViewModel : ViewModel() {
    private val servers = HashSet<ScannedServer>()
    val scannedServers = MutableLiveData<Set<ScannedServer>>(this.servers)

    fun addServer(server: ScannedServer) {
        if (!this.servers.add(server)) {
            this.servers.find { it == server }?.bumpTimestamp()
        }
        this.scannedServers.value = this.servers
    }

    fun prune() {
        this.servers.removeIf { it.hasExpired() }
        this.scannedServers.value = this.servers
    }
}
