package io.annaclemens.xivchat.ui.settings

import android.content.Context
import android.util.AttributeSet
import android.view.View
import androidx.preference.Preference
import androidx.preference.PreferenceManager
import androidx.preference.PreferenceViewHolder
import io.annaclemens.xivchat.R
import io.annaclemens.xivchat.databinding.KeyVisualisationBinding
import io.annaclemens.xivchat.util.hexStringToByteArray

class KeyPreference(context: Context, attrs: AttributeSet?) : Preference(context, attrs, android.R.attr.preferenceStyle) {

    init {
        this.layoutResource = R.layout.key_visualisation
    }

    private var itemView: View? = null

    override fun onBindViewHolder(holder: PreferenceViewHolder?) {
        super.onBindViewHolder(holder)

        if (holder == null) {
            return
        }

        // TODO: figure out why publicKeyLayout is null here so we don't have to set this in the XML
//        holder.itemView.publicKeyLayout.updatePaddingRelative(
//            start = android.R.attr.listPreferredItemPaddingStart,
//            end = android.R.attr.listPreferredItemPaddingEnd,
//        )
        this.itemView = holder.itemView
        this.setUpKey()
    }

    fun setUpKey() {
        val itemView = this.itemView ?: return

        val binding = KeyVisualisationBinding.bind(itemView)

        val key = PreferenceManager.getDefaultSharedPreferences(itemView.context).getString("keyPairPublic", "")!!
        binding.publicKeyName.text = itemView.context.getString(R.string.settings_current_key)
        binding.publicKey.text = key
        binding.publicKeyColours.generateDrawables(key.hexStringToByteArray() ?: ByteArray(0))
    }
}
