package io.annaclemens.xivchat.ui.settings

import android.os.Bundle
import android.text.InputType
import androidx.core.content.edit
import androidx.preference.EditTextPreference
import androidx.preference.Preference
import androidx.preference.PreferenceFragmentCompat
import io.annaclemens.xivchat.R
import io.annaclemens.xivchat.util.getApp

class PreferencesFragment : PreferenceFragmentCompat() {
    override fun onCreatePreferences(savedInstanceState: Bundle?, rootKey: String?) {
        this.setPreferencesFromResource(R.xml.preferences, rootKey)

        this.findPreference<Preference>("keyPairPublic")!!.let {
            it.onPreferenceClickListener = Preference.OnPreferenceClickListener {
                this.getApp().regenerateKeyPair()
                this.findPreference<KeyPreference>("keyPairPublicDisplay")!!.run {
                    this.setUpKey()
                }
                true
            }
        }

        this.findPreference<Preference>("trusted")!!.let {
            it.onPreferenceClickListener = Preference.OnPreferenceClickListener {
                val toRemove = this.getApp().preferences
                    .all
                    .keys
                    .filter { key -> key.startsWith("trusted:") }
                this.getApp().preferences.edit {
                    for (key in toRemove) {
                        this.remove(key)
                    }
                }
                true
            }
        }

        this.findPreference<EditTextPreference>("backlogAmount").let {
            it?.setOnBindEditTextListener { edit ->
                edit.inputType = InputType.TYPE_CLASS_NUMBER
            }
        }
    }
}
