package io.annaclemens.xivchat.util

import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.drawable.Drawable
import android.text.style.ImageSpan
import java.lang.ref.WeakReference

class CentredImageSpan(drawable: Drawable) : ImageSpan(drawable) {
    private var mDrawableRef: WeakReference<Drawable>? = null

    override fun getSize(paint: Paint, text: CharSequence?, start: Int, end: Int, fm: Paint.FontMetricsInt?): Int {
        val d = this.cachedDrawable
        val rect = d!!.bounds
        if (fm != null) {
            val pfm: Paint.FontMetricsInt = paint.fontMetricsInt
            // keep it the same as paint's fm
            fm.ascent = pfm.ascent
            fm.descent = pfm.descent
            fm.top = pfm.top
            fm.bottom = pfm.bottom
        }
        return rect.right

//        val d: Drawable = this.cachedDrawable!!
//        val rect = d.bounds
//
//        if (fm != null) {
//            fm.ascent = -rect.bottom
//            fm.descent = 0
//            fm.top = fm.ascent
//            fm.bottom = 0
//        }
//
//        return rect.right
    }

    override fun draw(canvas: Canvas, text: CharSequence?, start: Int, end: Int, x: Float, top: Int, y: Int, bottom: Int, paint: Paint) {
        val b: Drawable = this.cachedDrawable!!
        canvas.save()

        val transY = top + (bottom - top) / 2 - b.bounds.height() / 2

        canvas.translate(x, transY.toFloat())
        b.draw(canvas)
        canvas.restore()
    }

    // Redefined locally because it is a private member from DynamicDrawableSpan
    private val cachedDrawable: Drawable?
        get() {
            val wr: WeakReference<Drawable>? = this.mDrawableRef
            var d: Drawable? = null
            if (wr != null) d = wr.get()
            if (d == null) {
                d = this.drawable
                this.mDrawableRef = WeakReference(d)
            }
            return d
        }
}
