package io.annaclemens.xivchat.util

import android.content.ComponentName
import android.content.ServiceConnection
import android.os.IBinder
import androidx.activity.viewModels
import io.annaclemens.xivchat.ConnectionService
import io.annaclemens.xivchat.MainActivity
import io.annaclemens.xivchat.ui.servers.ServersViewModel

class ConnectionServiceConnection(val app: MainActivity) : ServiceConnection {
    override fun onServiceConnected(name: ComponentName?, service: IBinder?) {
        val serv = (service as ConnectionService.LocalBinder).getService()
        serv.app = this.app
        serv.bound = true
        val serversVm: ServersViewModel by this.app.viewModels()
        serversVm.connectionService.value = serv
    }

    override fun onServiceDisconnected(name: ComponentName?) {}
}