package io.annaclemens.xivchat.util

import android.graphics.Canvas
import android.graphics.ColorFilter
import android.graphics.PixelFormat
import android.graphics.Rect
import android.graphics.drawable.Drawable
import androidx.core.graphics.drawable.toBitmap

class CroppedDrawable(private val drawable: Drawable, private val crop: Rect) : Drawable() {
    override fun getIntrinsicWidth() = this.crop.width()

    override fun getIntrinsicHeight() = this.crop.height()

    override fun draw(canvas: Canvas) {
        val bitmap = this.drawable.toBitmap(this.drawable.intrinsicWidth, this.drawable.intrinsicHeight)
        canvas.drawBitmap(bitmap, this.crop, this.bounds, null)
    }

    override fun setAlpha(alpha: Int) {
        // Empty
    }

    override fun setColorFilter(cf: ColorFilter?) {
        // Empty
    }

    override fun getOpacity() = PixelFormat.OPAQUE
}