package io.annaclemens.xivchat.util

import io.annaclemens.xivchat.model.ChatType
import io.annaclemens.xivchat.model.message.ServerMessage
import io.annaclemens.xivchat.ui.FilterType

class MessageFilter(private val filters: Set<FilterType>) {
    var filterString: String? = null

    @OptIn(ExperimentalUnsignedTypes::class)
    fun allowed(message: ServerMessage): Boolean {
        if (message.channel == ChatType.AppSystem.code.toUShort()) {
            return true
        }

        if (!this.filters.any { it.matches(message.code()) }) {
            return false
        }

        val filterString = this.filterString
        if (filterString != null && !message.spans(null, null).contains(filterString, ignoreCase = true)) {
            return false
        }

        return true
    }
}
